﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Text;
using System.Threading;
using Newtonsoft.Json;

namespace data_sync_client
{
    class HistoryService
    {
        private TokenService tokenService;
        private DataHandler dataHandler;

        public HistoryService(TokenService tokenService, DataHandler dataHandler)
        {
            this.tokenService = tokenService;
            this.dataHandler = dataHandler;
        }

        public bool getHistoryData(string placeId, DateTime st, DateTime et)
        {
            bool ret = true;
            try
            {
                string uri = string.Format("https://dev.thuwater.com/api/data/range?placeId={0}&st={1}&et={2}",
                  placeId, st.ToString("yyyy-MM-dd HH:mm:ss"), et.ToString("yyyy-MM-dd HH:mm:ss"));
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(uri);
                request.Method = "GET";
                request.Headers.Set("X-TH-TOKEN", tokenService.genToken());
                request.Host="dev.thuwater.com";
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                if (response.StatusCode == HttpStatusCode.OK)
                {
                    Stream myResponseStream = response.GetResponseStream();
                    StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.GetEncoding("utf-8"));
                    string resBody = myStreamReader.ReadToEnd();
                    myStreamReader.Close();
                    myResponseStream.Close();
                    List<ThData> thDataList = JsonConvert.DeserializeObject<List<ThData>>(resBody);
                    dataHandler.handleDatas(thDataList);
                }
                else
                {
                    NetLog.WriteTextLog("err", string.Format("请求返回错误，请检查[{0}]", response.ToString()));
                    ret = false;
             
                }

            }
            catch (IOException e)
            {
                NetLog.WriteTextLog("err",e.Message);
                ret = false;
            }
            catch (Exception e)
            {
                NetLog.WriteTextLog("err", e.Message);
                ret = false;
            }
         return ret;
        }
    }
}
