﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.IO;
using System.Text;

namespace data_sync_client
{
    public class NetLog
    {
        /// <summary>  
    /// 写入日志到文本文件  
    /// </summary>  
    /// <param name="action">动作</param>  
    /// <param name="strMessage">日志内容</param>  
    /// <param name="time">时间</param>  
    public static void WriteTextLog(string action, string strMessage)  
    {  
        string path = AppDomain.CurrentDomain.BaseDirectory + @"System\Log\";  
        if (!Directory.Exists(path))
            Directory.CreateDirectory(path);
        
        DateTime time = DateTime.Now;
        string fileFullPath = path + time.ToString("yyyy-MM-dd") + "-log.txt";  
        StringBuilder str = new StringBuilder();  
        str.Append( "[" + time.ToString() + "]");  
        str.Append(action + "  :");  
        str.Append(strMessage);  
        StreamWriter sw;  
        if (!File.Exists(fileFullPath))  
        {  
            sw = File.CreateText(fileFullPath);  
        }  
        else  
        {  
            sw = File.AppendText(fileFullPath);  
        }  
        sw.WriteLine(str.ToString());  
        sw.Close();  
    } 
    }
}