﻿using System;
using YamlDotNet.Serialization;
using System.IO;
using System.Text;

namespace data_sync_client
{
    class Program
    {
        static void Main(string[] args)
        {
            //读取配置文件
            try
            {
                string curDir = Directory.GetCurrentDirectory();
                string configPath = curDir + @"\application.yml";
                if(!File.Exists(configPath))
                {
                    NetLog.WriteTextLog("err", "配置文件不存在");
                    return ;
                }
                StreamReader reader = File.OpenText(configPath);
                var deserializer = new Deserializer(); 
                var config = deserializer.Deserialize<Config>(reader);

                TokenService ts = new TokenService(config);

                DataHandler dh = new DataHandlerImpl();

                string strModel = config.Model;

                if(strModel.CompareTo("push") == 0)     // 推送模式情况
                {
                    NetLog.WriteTextLog("waring", "暂未实现");
                }   
                else if(strModel.CompareTo("pull") == 0)
                {
                    NetLog.WriteTextLog("info", "拉取模式开始");
                    PullService pullService = new PullService(ts, dh);
                    pullService.start();
                }
                else if (strModel.CompareTo("history") == 0)
                {
                    NetLog.WriteTextLog("info", "历史数据模式开始");
                    HistoryService historyService = new HistoryService(ts, dh);
                    // 这里使用的是示例时间与 placeId ，请根据实际情况修改 TODO
                    historyService.getHistoryData(
                        "8149",
                        new DateTime(2020, 10, 20, 0, 0, 0),
                        new DateTime(2020, 10, 20, 3, 0, 0)
                    );
                }

            }
            catch (Exception ex)
            {
                NetLog.WriteTextLog("err",ex.Message);
                Console.Write(ex);
            }
        }
    }
}
