﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Text;
using Newtonsoft.Json;

namespace data_sync_client
{
    class TokenService
    {
        public TokenService(Config config)
        {
            theWhKey = config.WhKey;
            expireTime = new DateTime(2014,1,1);
            tokenFreshbody = "username=" + config.UserName +"&password=" + config.PassWord ;
            init();
        }

        private void init()
        {
            if (!freshToken(true, 3, true))
            {
                String msg = "初始化获取token失败";
                NetLog.WriteTextLog("err", msg);
            }
        }

        private bool freshToken(bool retry, int maxRetry, bool forceFresh)
        {
            if (!forceFresh && expireTime.CompareTo(DateTime.Now) > 0)
            {
                return true;
            }
            lock(loc)
            {
                if (expireTime.CompareTo(DateTime.Now) > 0)
                {
                    return true;
                }
                int retryCount = 0;
                do
                {
                    retryCount++;
                    HttpWebRequest request = null;
                    HttpWebResponse response = null;
                    Stream reqStream = null;
                    request = (HttpWebRequest)WebRequest.Create("https://dev.thuwater.com/api/permission/token");
                    request.Method = "POST";
                    request.Timeout = 90000;

                    //设置POST的数据类型和长度
                    request.Host = "dev.thuwater.com";
                    request.ContentType = "application/x-www-form-urlencoded";
                    byte[] data = Encoding.UTF8.GetBytes(tokenFreshbody);
                    request.ContentLength = data.Length;

                    //往服务器写入数据
                    reqStream = request.GetRequestStream();
                    reqStream.Write(data, 0, data.Length);
                    reqStream.Close();
                    //获取服务端返回
                    response = (HttpWebResponse)request.GetResponse();
                    Stream streamReceive = response.GetResponseStream();

                    StreamReader streamReader = new StreamReader(streamReceive, Encoding.UTF8);
                    string strRespose = streamReader.ReadToEnd();
                    streamReceive.Close();
                    streamReader.Close();

                    if(strRespose.Length > 0)
                    {
                       var resBody =  JsonConvert.DeserializeObject<Dictionary<object, object>>(strRespose);
                        this.token = resBody["token"] as string;
                        string strValidDate = resBody["validDate"] as string;
                        this.expireTime = DateTime.ParseExact(strValidDate, "yyyy-MM-dd HH:mm:ss", System.Globalization.CultureInfo.CurrentCulture);
                        return true;
                    }
                } while (retry && retryCount <= maxRetry + 1);
            }
            return false;
        }
        public bool validWhKey(string thisWhKey)
        {
            return this.theWhKey.Equals(thisWhKey);
        }

        public String genToken()
        {
            if (expireTime.CompareTo(DateTime.Now) < 0)
            {
                freshToken(true, 3, true);
            }
            return token;
        }

        public String genToken(bool forceFresh)
        {
            if (forceFresh)
            {
                freshToken(true, 3, forceFresh);
            }
            return genToken();
        }

        private String theWhKey = "";
        private String token = "";
        private DateTime expireTime;
        private string tokenFreshbody;
        private static readonly object loc = new object();
    }
}
